package Package1;

import java.awt.*;
import javax.swing.*;
import java.awt.Color;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.MouseMotionAdapter;

public class CheckerboardMouse extends JFrame {

    private final int ROWS = 8;
    private final int COLS = 8;
    private final int NUM = ROWS * COLS;
    private JPanel[] panel = new JPanel[NUM];
    private Color color1 = Color.WHITE;
    private Color color2 = Color.BLACK;
    private int currentRow = -1;
    private int currentCol = -1;
    private int currentX = -1;
    private int currentY = -1;

    public CheckerboardMouse() {
        super("Checkerboard");
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        setLayout(new GridLayout(ROWS, COLS));
        for (int x = 0; x < NUM; x++) {
            panel[x] = new JPanel();
            MouseAdapterPanel mouseAdapterPanel = new MouseAdapterPanel();
            panel[x].addMouseListener(mouseAdapterPanel);
            final int row = x % COLS + 1;
            final int col = x / ROWS + 1;
            panel[x].addMouseMotionListener(new MouseMotionAdapter() {
                @Override
                public void mouseMoved(MouseEvent e) {
                    currentRow = row;
                    currentCol = col;
                    currentX = e.getX();
                    currentY = e.getY();
                    refreshTitle();
                }
            });
            add(panel[x]);
            if ((x + x / COLS) % 2 == 1)
                panel[x].setBackground(color1);
            else
                panel[x].setBackground(color2);        }
    }

    class MouseAdapterPanel extends MouseAdapter {
        @Override
        public void mouseClicked(MouseEvent e) {
            JPanel p = (JPanel)e.getSource();
            if (p.getBackground().equals(color1))
                p.setBackground(color2);
            else
                p.setBackground(color1);
        }
    }
    
    private void refreshTitle() {
        setTitle("Row: " + currentRow + ", Col: " + currentCol + ", X: " + currentX + ", Y: " + currentY);
    }

    public static void main(String[] args) {
        CheckerboardMouse frame = new CheckerboardMouse();
        frame.setSize(400, 400);
        frame.setVisible(true);
    }
}