package jMusic;

import jm.JMC;
import jm.util.*;
import jm.music.data.*;
import jm.music.tools.ca.*;

/* --------------------
* A class for making music from Cellular Automata clculations
* original @author Andrew Troedson and Andrew Brown
* ---------------------
 */
public class AutomataMusic implements JMC {

    static boolean[][] cells = new boolean[10][10];
    int maxNotes = 100;
    Score score = new Score("The Cellular Drunk");
    Part piano = new Part("piano", 0, 0);
    Phrase phr = new Phrase();

    public static void main(String[] args) {
        new AutomataMusic();
    }

    public AutomataMusic() {
        phr.addRest(new Rest(SQ));
        int liveCellCounter;
        int noteNumber;
        // arguments are: width, height, seed, and wrap around?
        // seed is the probability of life when initializing the automaton (cell by cell)
        // in this case 20 means every cell is initialized with 20% of probability to be alive
        CellularAutomata CA = new CellularAutomata(cells.length, cells[0].length, 30, false);

        // A window with cell size and last 2 ints as x & y pos
        DrawCA DCA = new DrawCA(CA, "Big Cellular Automata Music", 30, 100, 100);
        // do the iterations
        for (int i = 0; i < maxNotes; i++) {
            CA.evolve();
            CA.print();
            cells = CA.getAllStates();
            //do jMusic
            //counts the number of live cells in the current iteration
            liveCellCounter = 0;
            for (int k = 0; k < cells.length; k++)
                for (int j = 0; j < cells[0].length; j++)
                    if (CA.getState(k, j) == true)
                        liveCellCounter++;
            noteNumber = liveCellCounter + (127 - cells.length * cells[0].length); //pitch offset
            Note n = new Note(noteNumber, SQ);
            phr.addNote(n);

            //wait a bit to make it look more pretty
            try {
                Thread.sleep(100);
                System.out.println("Iteration " + i + " of " + maxNotes);
            } catch (Exception e) {
            }
            DCA.repaint();
            // if the automaton is completely dead, try to "resurrect" some cells
            if (liveCellCounter == 0)
                CA.setGrid(1);
        }
        piano.addPhrase(phr);
        score.addPart(piano);

        Play.midi(score);
    }
}
