package jMusic;

import jm.audio.*;
import jm.audio.io.SampleOut;
import jm.audio.synth.*;

public class SampleInstrument extends jm.audio.Instrument {
    private int sampleRate;

    public SampleInstrument(int sampleRate) {
        this.sampleRate = sampleRate;
    }

    @Override
    public void createChain() throws AOException {
        Oscillator oscSine = new Oscillator(this, Oscillator.SINE_WAVE, this.sampleRate);
        
        Envelope env = new Envelope(oscSine, new EnvPoint[] {
                                        new EnvPoint(0.0f, 0.0f),
                                        new EnvPoint(0.5f, 1.0f),
                                        new EnvPoint(0.9f, 0.4f),
                                        new EnvPoint(1.0f, 0.0f) });
        SampleOut sout = new SampleOut(env);
    }

}
