package jSyn;

import com.jsyn.JSyn;
import com.jsyn.Synthesizer;
import com.jsyn.data.FloatSample;
import com.jsyn.unitgen.LineOut;
import com.jsyn.unitgen.UnitOscillator;
import com.jsyn.unitgen.VariableRateDataReader;
import com.jsyn.unitgen.VariableRateMonoReader;

public class PlaySquare {
    Synthesizer synth;
    UnitOscillator osc;
    LineOut lineOut;
    VariableRateDataReader samplePlayer;

    private void test() throws InterruptedException {
        synth = JSyn.createSynthesizer();
        synth.start();
        synth.add(lineOut = new LineOut());
        lineOut.start();

        float[] data = new float[44100];
        float value = 0.7f;
        for (int i = 0; i < data.length; i++) {
            data[i] = value;
            // cambia segno ogni 441 valori (100Hz visto che il sample rate è 44100 di default)
            if (i  % 441 == 0) 
                value = -value;
        }
        FloatSample sample = new FloatSample(data);
        synth.add(samplePlayer = new VariableRateMonoReader());
        // imposta la velocità di lettura dei frame al doppio del frame rate: 8va
        samplePlayer.rate.set(sample.getFrameRate() * 2);
        samplePlayer.output.connect(0, lineOut.input, 0);
        samplePlayer.output.connect(0, lineOut.input, 1);
        samplePlayer.dataQueue.queueLoop(sample, 0, sample.getNumFrames(), 1);
        do {
            synth.sleepFor(1.0);
        } while (samplePlayer.dataQueue.hasMore());
        synth.stop();
    }

    public static void main(String[] args) throws InterruptedException {
        new PlaySquare().test();
    }
}