package patches;

/**************
** WARNING - this code automatically generated by Syntona.
** The real source is probably a Syntona patch.
** Do NOT edit this file unless you copy it to another directory and change the name.
** Otherwise it is likely to get clobbered the next time you
** export Java source code from Syntona.
**
** Syntona is available from: http://www.softsynth.com/syntona/
*/

import com.jsyn.JSyn;
import com.jsyn.Synthesizer;
import com.jsyn.ports.UnitOutputPort;
import com.jsyn.unitgen.UnitVoice;
import com.jsyn.unitgen.SawtoothOscillatorBL;
import com.jsyn.unitgen.PowerOfTwo;
import com.jsyn.ports.UnitInputPort;
import com.jsyn.unitgen.Multiply;
import com.jsyn.unitgen.SineOscillator;
import com.softsynth.shared.time.TimeStamp;
import com.jsyn.unitgen.PassThrough;
import com.jsyn.unitgen.EnvelopeDAHDSR;
import com.jsyn.unitgen.Circuit;
import com.jsyn.unitgen.LineOut;


public class Syntona {
    // The vibrato is supplied by the sineLFO. The vibEnv has a delay that causes the vibrato to come in after the note has played for a while. The aPower2 is used to convert from a pitch vibrato to a frequency scaler.
    public static class MyVoice extends Circuit implements UnitVoice {
        // Declare units and ports.
        PassThrough mFrequencyPassThrough;
        public UnitInputPort frequency;
        PassThrough mAmplitudePassThrough;
        public UnitInputPort amplitude;
        PassThrough mOutputPassThrough;
        public UnitOutputPort output;
        SawtoothOscillatorBL mSawOscBL;
        EnvelopeDAHDSR mAmpEnv;
        SineOscillator mSineLFO;
        PowerOfTwo mAPower2;
        Multiply mAtimes;
        EnvelopeDAHDSR mVibEnv;

        // Declare inner classes for any child circuits.

        public MyVoice() {
            // Create unit generators.
            add(mFrequencyPassThrough = new PassThrough());
            addPort(frequency = mFrequencyPassThrough.input, "frequency");
            add(mAmplitudePassThrough = new PassThrough());
            addPort(amplitude = mAmplitudePassThrough.input, "amplitude");
            add(mOutputPassThrough = new PassThrough());
            addPort(output = mOutputPassThrough.output, "output");
            add(mSawOscBL = new SawtoothOscillatorBL());
            add(mAmpEnv = new EnvelopeDAHDSR());
            add(mSineLFO = new SineOscillator());
            add(mAPower2 = new PowerOfTwo());
            add(mAtimes = new Multiply());
            add(mVibEnv = new EnvelopeDAHDSR());
            // Connect units and ports.
            mFrequencyPassThrough.output.connect(mAtimes.inputA);
            mAmplitudePassThrough.output.connect(mSawOscBL.amplitude);
            mSawOscBL.output.connect(mAmpEnv.amplitude);
            mAmpEnv.output.connect(mOutputPassThrough.input);
            mSineLFO.output.connect(mVibEnv.amplitude);
            mAPower2.output.connect(mAtimes.inputB);
            mAtimes.output.connect(mSawOscBL.frequency);
            mVibEnv.output.connect(mAPower2.input);
            // Setup
            frequency.setup(50.0, 261.6255653005986, 2000.0);
            amplitude.setup(0.0, 0.5, 1.0);
            mAmpEnv.input.set(0.0);
            mAmpEnv.delay.set(0.0);
            mAmpEnv.attack.set(0.060224443983714473);
            mAmpEnv.hold.set(0.0);
            mAmpEnv.decay.set(1.8956400000000002);
            mAmpEnv.sustain.set(0.17423755913827715);
            mAmpEnv.release.set(0.42750718526574294);
            mSineLFO.frequency.set(5.550226872349158);
            mSineLFO.amplitude.set(0.10746473638015736);
            mVibEnv.input.set(0.0);
            mVibEnv.delay.set(0.5036202477543645);
            mVibEnv.attack.set(1.0344014388356613);
            mVibEnv.hold.set(0.0);
            mVibEnv.decay.set(0.2);
            mVibEnv.sustain.set(1.0);
            mVibEnv.release.set(0.1481530495629968);
        }

        @Override
        public void noteOn(double frequency, double amplitude, TimeStamp timeStamp) {
            this.frequency.set(frequency, timeStamp);
            this.amplitude.set(amplitude, timeStamp);
            mAmpEnv.input.on(timeStamp);
            mVibEnv.input.on(timeStamp);
        }

        @Override
        public void noteOff(TimeStamp timeStamp) {
            mAmpEnv.input.off(timeStamp);
            mVibEnv.input.off(timeStamp);
        }

        @Override
        public UnitOutputPort getOutput() {
            return output;
        }
    }

    public static void main(String[] args) {
         // Create a context for the synthesizer.
        Synthesizer synth = JSyn.createSynthesizer();

        MyVoice myVoice;
        // Add a tone generator.
        synth.add(myVoice = new MyVoice());

        LineOut lineOut;
        // Add an output mixer.
        synth.add(lineOut = new LineOut());
        // Connect the oscillator to the left and right audio output.
        myVoice.getOutput().connect(0, lineOut.input, 0);
        myVoice.getOutput().connect(0, lineOut.input, 1);

        // Start synthesizer using default stereo output at 44100 Hz.
        synth.start();

        // Get synthesizer time in seconds.
        double timeNow = synth.getCurrentTime();

        // Advance to a near future time so we have a clean start.
        TimeStamp timeStamp = new TimeStamp(timeNow + 0.5);

        // We only need to start the LineOut. It will pull data from the oscillator
        lineOut.start(timeStamp);

        // Schedule a note on and off.
        double freq = 220.0; // hertz
        double timeBetweenNotes = 1.0;
        double noteDuration = 2;
        myVoice.noteOn(freq, 0.5, timeStamp);
        myVoice.noteOff(timeStamp.makeRelative(noteDuration));

        // Schedule this to happen a bit later.
        timeStamp = timeStamp.makeRelative(timeBetweenNotes);
        freq *= 1.5; // up a perfect fifth
        myVoice.noteOn(freq, 0.5, timeStamp);
        myVoice.noteOff(timeStamp.makeRelative(noteDuration));

        // Sleep while the song is being generated in the background thread.
        try {
            System.out.println("Sleep while synthesizing.");
            synth.sleepUntil(timeStamp.getTime() + 2.0);
            System.out.println("Woke up...");
        } catch (InterruptedException e) {
            e.printStackTrace();
        }

        // Stop everything.
        synth.stop();
    }
}
